#ifndef BUFFER_H
#define BUFFER_H

#include "../common/scene.h"
#include "../common/Color.h"

extern SlimScene* main_scene;

//void flush_Primitive_buffer();
INLINE void flush_Color_buffer();
//INLINE int array_offset(int x, int y);
INLINE void get_sample(int x, int y, Color* c, int* obj);
//INLINE int get_PrimitiveBase(int x, int y);
//INLINE void get_Color(int x, int y, Color* c);
INLINE intersect_data* get_idata(int x, int y);
//INLINE void set_Color(int x, int y, Color *c);
//INLINE void get_normal(int x, int y, vector3 v);
//INLINE intersect_data* get_idata(int x, int y);
INLINE void clear_idata_buffer();

inline int array_offset(int x, int y)
{
	static int ptr;  //static to avoid redeclaration each call
	//printd(INSANE, "Getting offset for: %i, %i\n", x, y);
	ptr = x + y * main_scene->width;
	return ptr;
}

inline void set_Color(int x, int y, Color *c)
{
	if(x < 0 || y < 0)
		return;
	if(x > main_scene->width-1 || y > main_scene->height-1)
		return;
	c->toRGB();
	
	main_scene->colorOutput->setIndex(x,y,*c);
}


inline void get_Color(int x, int y, Color* c)
{
	*c = main_scene->colorOutput->getIndex(x,y);
	return;
}


inline intersect_data* get_idata(int x, int y)
{
	int offset = array_offset(x, y);
	void *ptr;
	
	ptr = (void*) (offset*sizeof(intersect_data));
	return &main_scene->intersect_front[offset];
}




#endif
